/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2010 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: GuiBuilderFirstFrame.java 20819 2011-02-02 16:00:53Z benoitf $
 * --------------------------------------------------------------------------
 */
package org.ow2.jonas.autostart.frame;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.Insets;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SpringLayout;
import javax.swing.border.EmptyBorder;
import javax.swing.border.EtchedBorder;

import org.ow2.jonas.autostart.utility.SpringUtilities;

/**
 * This class creates the first frame panel.
 * @author skabore
 */
public final class GuiBuilderFirstFrame extends FirstFrame {

    public GuiBuilderFirstFrame(final int steps) {
        super(steps);
        makeFrame();
    }

    /**
     * @return contentPanel1.
     */
    @Override
    public JPanel getContentPanel() {

        JPanel contentPanel1 = new JPanel();
        JPanel jPanel1 = new JPanel(new SpringLayout());
        JPanel jPanelStep1 = new JPanel(new SpringLayout());
        JPanel jPanelStep2 = new JPanel(new SpringLayout());
        JPanel jPanelStep3 = new JPanel(new SpringLayout());
        JPanel jPanelStep4 = new JPanel(new SpringLayout());
        JPanel jPanelStep5 = new JPanel(new SpringLayout());
        JPanel jPanelStep6 = new JPanel(new SpringLayout());
        JPanel jPanelStep7 = new JPanel(new SpringLayout());
        JPanel jPanelStep8 = new JPanel(new SpringLayout());

        JLabel blankSpace = new JLabel();
        JLabel jLabel0 = new JLabel("To create JOnAS Auto-Start Starter JAR file," + " please follow these 7 steps below.");
        jLabel0.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel1 = new JLabel("This tool packages JEE applications with" + " JOnAS server in an auto runnable archive.");
        jLabel1.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel2 = new JLabel("Read and accept the license agreements.");
        jLabel2.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel3 = new JLabel("Select the Java EE applications to include" + " in the packaging process.");
        jLabel3.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel4 = new JLabel("You have three options for getting JOnAS server:");
        jLabel4.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel4a = new JLabel("- From JOnAS website: JOnAS zip file will" + " be downloaded from JOnAS website.");
        jLabel4a.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel4b = new JLabel(" You need to select" + " your JOnAS version and type.");
        jLabel4b.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel4c = new JLabel("- From disk: If you have a valid JOnAS folder in"
                + " your disk, you can choose this option.");
        jLabel4c.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel4d = new JLabel("- From existing zip file: If you have an existing" + " JOnAS zip file in your disk");
        jLabel4d.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel4e = new JLabel(" or you need to use other zip" + " file from other website, select this option.");
        jLabel4e.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel jLabel5 = new JLabel("Enter the values to copy or download" + " JOnAS server.");
        jLabel5.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel jLabel6 = new JLabel("The step is an advanced configuration task" + " where you can customize JOnAS server.");
        jLabel6.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel jLabel7 = new JLabel("You have all Java EE applications which will be" + " included in the packaging process.");
        jLabel7.setFont(new Font(Font.SERIF, Font.ITALIC, 12));
        JLabel jLabel7a = new JLabel("Optionaly, you can rename the Java archive" + " and choose its location");
        jLabel7a.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel jLabel8 = new JLabel("You can see, in the text area, step by steps" + " the packaging process.");
        jLabel8.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel jLabel9 = new JLabel("Press the 'Next' button to continue...");
        jLabel9.setFont(new Font(Font.SERIF, Font.BOLD, 14));

        JLabel step1 = new JLabel(underLineLabel("Step :1 Introduction note"));
        step1.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel step2 = new JLabel(underLineLabel("Step 2: License agreements"));
        step2.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel step3 = new JLabel(underLineLabel("Step 3: Applications to include"));
        step3.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel step4 = new JLabel(underLineLabel("Step 4:" + " Getting JOnAS server option"));
        step4.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel step5 = new JLabel(underLineLabel("Step 5: JOnAS server location"));
        step5.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel step6 = new JLabel(underLineLabel("Step 6: (Optional) JOnAS server" + " configuration"));
        step6.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel step7 = new JLabel(underLineLabel("Step 7: Build process summary"));
        step7.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        JLabel step8 = new JLabel(underLineLabel("Step 8: Build process"));
        step8.setFont(new Font(Font.SERIF, Font.ITALIC, 12));

        contentPanel1.setLayout(new BorderLayout());

        JPanel titlePanel = new JPanel();
        titlePanel.setLayout(new BorderLayout());
        titlePanel.setBackground(Color.gray);

        getWelcomeTitle().setBackground(Color.gray);
        getWelcomeTitle().setFont(new Font("MS Sans Serif", Font.BOLD, 14));
        getWelcomeTitle().setText("Welcome to JOnAS AutoStart :: Builder !");
        getWelcomeTitle().setBorder(new EmptyBorder(new Insets(10, 10, 10, 10)));
        getWelcomeTitle().setOpaque(true);
        titlePanel.add(getWelcomeTitle(), BorderLayout.CENTER);
        titlePanel.add(getWelcomeTitle(), BorderLayout.SOUTH);
        titlePanel.add(new JLabel("1/" + getSteps() + "  "), BorderLayout.EAST);
        contentPanel1.add(titlePanel, BorderLayout.NORTH);

        jPanel1.add(blankSpace);

        jPanelStep1.add(step1);
        jPanelStep1.add(jLabel1);
        jPanelStep1.add(jLabel0);
        SpringUtilities.makeCompactGrid(jPanelStep1, 3, 1, 0, 0, 0, 0);
        jPanel1.add(jPanelStep1);
        jPanelStep2.add(step2);
        jPanelStep2.add(jLabel2);
        SpringUtilities.makeCompactGrid(jPanelStep2, 2, 1, 0, 0, 0, 0);
        jPanel1.add(jPanelStep2);

        jPanelStep3.add(step3);
        jPanelStep3.add(jLabel3);
        SpringUtilities.makeCompactGrid(jPanelStep3, 2, 1, 0, 0, 0, 0);
        jPanel1.add(jPanelStep3);

        jPanelStep4.add(step4);
        jPanelStep4.add(jLabel4);
        jPanelStep4.add(jLabel4a);
        jPanelStep4.add(jLabel4b);
        jPanelStep4.add(jLabel4c);
        jPanelStep4.add(jLabel4d);
        jPanelStep4.add(jLabel4e);
        SpringUtilities.makeCompactGrid(jPanelStep4, 7, 1, 0, 0, 0, 0);
        jPanel1.add(jPanelStep4);

        jPanelStep5.add(step5);
        jPanelStep5.add(jLabel5);
        SpringUtilities.makeCompactGrid(jPanelStep5, 2, 1, 0, 0, 0, 0);
        jPanel1.add(jPanelStep5);

        jPanelStep6.add(step6);
        jPanelStep6.add(jLabel6);
        SpringUtilities.makeCompactGrid(jPanelStep6, 2, 1, 0, 0, 0, 0);
        jPanel1.add(jPanelStep6);

        jPanelStep7.add(step7);
        jPanelStep7.add(jLabel7);
        jPanelStep7.add(jLabel7a);
        SpringUtilities.makeCompactGrid(jPanelStep7, 3, 1, 0, 0, 0, 0);
        jPanel1.add(jPanelStep7);

        jPanelStep8.add(step8);
        jPanelStep8.add(jLabel8);
        SpringUtilities.makeCompactGrid(jPanelStep8, 2, 1, 0, 0, 0, 0);
        jPanel1.add(jPanelStep8);

        jPanel1.add(new JLabel(" "));
        jPanel1.add(jLabel9);
        SpringUtilities.makeCompactGrid(jPanel1, 11, 1, 6, 6, 6, 6);

        contentPanel1.add(jPanel1, BorderLayout.CENTER);
        return contentPanel1;
    }

    @Override
    public void makeFrame() {
        setContentPanel(getContentPanel());
        setIcon(getImageIcon());
        setLayout(new SpringLayout());
        if (getIcon() != null) {
            getIconLabel().setIcon(getIcon());
        }
        getIconLabel().setBorder(new EtchedBorder(EtchedBorder.RAISED));
        add(getIconLabel());
        getContentPanel().setBorder(new EtchedBorder(EtchedBorder.RAISED));
        add(getContentPanel());
        SpringUtilities.makeCompactGrid(this, 1, 2, 0, 0, 0, 0);
    }
}
